dnl PPLite: a lightweight library for convex polyhedra derived from PPL.
dnl Copyright (C) 2010-2017 BUGSENG srl (http://bugseng.com)
dnl Copyright (C) 2018 Enea Zaffanella <enea.zaffanella@unipr.it>
dnl
dnl This file is part of PPLite.
dnl
dnl This program is free software: you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation, either version 3 of the License, or
dnl (at your option) any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program.  If not, see <http://www.gnu.org/licenses/>.

dnl A function to check for C++11 features.

AC_DEFUN([AC_CHECK_CXX11],
[
AC_LANG_PUSH(C++)
AC_MSG_CHECKING([if the C++ compiler supports C++11 features])
AC_COMPILE_IFELSE([AC_LANG_SOURCE([[
template <typename T>
struct check final {
  static constexpr T value{ __cplusplus };
};

typedef check<check<bool>> right_angle_brackets;

int a;
decltype(a) b;

typedef check<int> check_type;
check_type c{};
check_type&& cr = static_cast<check_type&&>(c);

static_assert(check_type::value == 201103L, "C++11 compiler");
]])],
    AC_MSG_RESULT(yes)
    ac_cv_check_cxx11=yes,
    AC_MSG_RESULT(no)
    ac_cv_check_cx11=no
  )
AC_LANG_POP(C++)
if test "$ac_cv_check_cxx11" = yes; then
  AC_DEFINE(HAVE_CXX11,,
  [Defined if the C++compiler supports C++11 features.])
fi
])
